﻿/******************************
Copyright (c) 2009, Avanade
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

* Neither the name of Avanade nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
******************************/

using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.Serialization;

namespace PhpSiteGenerator
{

    public class CssProperties
    {
        private List<CssStyle> _styles = new List<CssStyle>();

        //Public constructor creates the object from a saved Xml file
        public CssProperties()
        {
          
            XmlSerializer ns = new XmlSerializer(typeof(List<CssStyle>));

            //Load the xml doc from teh config file file
            XmlDocument doc = new XmlDocument();
            doc.Load("Configs\\cssproperties.xml");
            XmlNodeReader nodeReader = new XmlNodeReader(doc);

            //Create blank settings object for XxmlReader
            XmlReaderSettings settings = new XmlReaderSettings();

            //Create the object by desiarlization
            XmlReader xmlConfigReader = XmlReader.Create(nodeReader, settings);
            _styles = (List<CssStyle>)ns.Deserialize(xmlConfigReader);
           
           
        }

        //Read only access since user shouldn't alter list
        public List<CssStyle> Styles          
        {
            get{ return _styles; }
        }

        
    }

    //A style name and collection of name value pairs
    public class CssStyle
    {
        private List<CssInfo> _cssProperties = new List<CssInfo>();
        private String _cssName;

        public CssStyle()
        {
            
        }

        public List<CssInfo> CssProperties 
        {
            get{ return _cssProperties; }
            set { _cssProperties = value; }
        }

        public string CssName
        {
            get { return _cssName; }
            set { _cssName = value; }
        }
    }

    //Name value pairs of a CSS style
    public class CssInfo
    {
        
        public CssInfo()
        {          
        }

        public string CssStyle { get; set; }
        public string CssValue { get; set; }
        public List<string> ValidValues { get; set; }

    }
}
